首页 > 代码库 > hdu2639
hdu2639
这是一个典型的求第k优解的问题。。背包九讲上面都有。。。所有我只讲一下我的思路。。求第k优解就是在最优解的复杂度上增加了一个k,每次用一个物品去更新dp[v]的时候用一个数组保存才来。。然后排序,题目说要去重,那就很好办了。。然后经过N个物品的更新,那么最后的答案就是打dp[V][K]..
题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2639
题目为:
Bone Collector II
Time Limit: 5000/2000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 2037 Accepted Submission(s): 1058
Problem Description
The title of this problem is familiar,isn‘t it?yeah,if you had took part in the "Rookie Cup" competition,you must have seem this title.If you haven‘t seen it before,it doesn‘t matter,I will give you a link:
Here is the link:http://acm.hdu.edu.cn/showproblem.php?pid=2602
Today we are not desiring the maximum value of bones,but the K-th maximum value of the bones.NOTICE that,we considerate two ways that get the same value of bones are the same.That means,it will be a strictly decreasing sequence from the 1st maximum , 2nd maximum .. to the K-th maximum.
If the total number of different values is less than K,just ouput 0.
Here is the link:http://acm.hdu.edu.cn/showproblem.php?pid=2602
Today we are not desiring the maximum value of bones,but the K-th maximum value of the bones.NOTICE that,we considerate two ways that get the same value of bones are the same.That means,it will be a strictly decreasing sequence from the 1st maximum , 2nd maximum .. to the K-th maximum.
If the total number of different values is less than K,just ouput 0.
Input
The first line contain a integer T , the number of cases.
Followed by T cases , each case three lines , the first line contain two integer N , V, K(N <= 100 , V <= 1000 , K <= 30)representing the number of bones and the volume of his bag and the K we need. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone.
Followed by T cases , each case three lines , the first line contain two integer N , V, K(N <= 100 , V <= 1000 , K <= 30)representing the number of bones and the volume of his bag and the K we need. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone.
Output
One integer per line representing the K-th maximum of the total value (this number will be less than 231).
Sample Input
3 5 10 2 1 2 3 4 5 5 4 3 2 1 5 10 12 1 2 3 4 5 5 4 3 2 1 5 10 16 1 2 3 4 5 5 4 3 2 1
Sample Output
12 2 0
Author
teddy
Source
百万秦关终属楚
代码为:
#include<cstring> #include<cstdio> #include<iostream> #include<algorithm> using namespace std; int dp[1005][40],cost[105],value[105],ans[10000]; int N,V,K; bool cmp(int a,int b) { return a>b; } int main() { int t,i,j,cnt,pos,k; scanf("%d",&t); while(t--) { memset(dp,0,sizeof(dp)); scanf("%d%d%d",&N,&V,&K); for(i=1;i<=N;i++) scanf("%d",&value[i]); for(i=1;i<=N;i++) scanf("%d",&cost[i]); for(i=1;i<=N;i++) for(j=V;j>=cost[i];j--) { cnt=1; for(k=1;k<=K;k++) { ans[cnt++]=dp[j][k]; ans[cnt++]=dp[j-cost[i]][k]+value[i]; } sort(ans+1,ans+cnt,cmp); int x=1; for(k=1;k<cnt-1;k++) { if(x>K) break; if(ans[k]!=ans[k+1]) dp[j][x++]=ans[k]; } } printf("%d\n",dp[V][K]); } return 0; }
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。